//
// Created by trokay on 18.06.23.
//

#ifndef MC_02_UART_MC0203_PROTOCOL_H
#define MC_02_UART_MC0203_PROTOCOL_H

union ip_t {
    int addr;
    unsigned char addr_bytes[4];
};

struct config_t {
    union ip_t ip;
    union ip_t netmask;
    union ip_t gw;
    union ip_t dns;
    unsigned char dhcp;
};

void decode_message(unsigned char *data, int size, int *new_size);

unsigned char calc_checksum(const char *data, int size);

void encode_message(unsigned char *data, int size, int *new_size);

int extract_data_from_command(const char *source, int src_size, char *dest, int *dst_size);

void convert_from_string(const char response[17],
                         char *dhcp,
                         char ip[4],
                         char netmask[4],
                         char gw[4],
                         char dns[4]);

void convert_to_string(char response[17],
                       const char *dhcp,
                       const char ip[4],
                       const char netmask[4],
                       const char gw[4],
                       const char dns[4]);

void get_response(unsigned char response[256],
                  int *response_size,
                  char *data,
                  int data_size,
                  char resp_code,
                  char index);

#endif //MC_02_UART_MC0203_PROTOCOL_H
