//
// Created by trokay on 13.06.23.
//
#include "network.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <sys/ioctl.h>

#include <sys/socket.h>

// ioctl
#include <stddef.h>
#include <net/route.h>

#define BUFSIZE 8192
#define ifreq_offsetof(x)  offsetof(struct ifreq, x)

const char *DNS_command = "cat /etc/resolv.conf|grep -im 1 '^nameserver' |cut -d ' ' -f2";
const char *gateway_command = "ip route show default | awk '{print $3}'";

const char *RESOLV_FILE = "/etc/resolv.conf";
const char *INTERFACE_FILE = "/etc/network/interfaces";

int parse_ip_address(const char *ip_string, unsigned char numbers[4]);

char check_dhcp_enabled();

int delNullRoute(const char *address);

int execute_command(const char *command, char string[16]);

struct ifaddrs *test;

int init_network_interface(char *interface_name) {
    struct ifaddrs *addresses;
    if (getifaddrs(&addresses) == -1) {
        printf("getifaddrs call failed\n");
        return 1;
    }

    struct ifaddrs *ifa = addresses;
    while (ifa != NULL) {
        if (ifa->ifa_addr != NULL
            && ifa->ifa_addr->sa_family == AF_INET
            && ifa->ifa_netmask != NULL
            && ifa->ifa_flags & IFF_UP
            && strcmp(ifa->ifa_name, interface_name) == 0
                ) {
            test = ifa;
            freeifaddrs(addresses);
            return 0;
        }
        ifa = ifa->ifa_next;
    }
    freeifaddrs(addresses);
    return 1;
}

/*
 * Возвращает значения в виде [192, 168, 1, 1]
 */
void get_c(char *dhcp, char ip[4], char netmask[4], char gw[4], char dns[4]) {
    char dd[INET_ADDRSTRLEN];
    unsigned char tmp[4];
    *dhcp = 0;
    //test
    ip[0] = 192;
    ip[1] = 168;
    ip[2] = 15;
    ip[3] = 144;

    netmask[0] = 255;
    netmask[1] = 255;
    netmask[2] = 255;
    netmask[3] = 0;

    gw[0] = 192;
    gw[1] = 168;
    gw[2] = 15;
    gw[3] = 2;

    dns[0] = 192;
    dns[1] = 168;
    dns[2] = 15;
    dns[3] = 2;

    //test



    // Get DHCP state
    //*dhcp = check_dhcp_enabled();
    //dhcp в конце, а не первый
    *dhcp = 0x00;
    struct ifaddrs *ifa = test;

    // Get IP address
    struct sockaddr_in *address = (struct sockaddr_in *) ifa->ifa_addr;
    inet_ntop(AF_INET, &(address->sin_addr), dd, INET_ADDRSTRLEN);
    parse_ip_address(dd, tmp);
    memcpy(ip, tmp, 4);

    // Get netmask
    address = (struct sockaddr_in *) ifa->ifa_netmask;
    inet_ntop(AF_INET, &(address->sin_addr), dd, INET_ADDRSTRLEN);
    parse_ip_address(dd, tmp);
    memcpy(netmask, tmp, 4);

    // Get gateway
    execute_command(gateway_command, dd);
    parse_ip_address(dd, tmp);
    memcpy(gw, tmp, 4);

    // Get DNS
    execute_command(DNS_command, dd);
    parse_ip_address(dd, tmp);
    memcpy(dns, tmp, 4);

    //
//    ip[3] += 1;
//    gw[3] += 1;

}

int set_c(char *dhcp,
          char ip[4],
          char netmask[4],
          char gw[4],
          char dns[4],
          char *interface_name) {

    unsigned char old_dhcp, old_ip[4], old_netmask[4], old_gw[4], old_dns[4];
    get_c(&old_dhcp, old_ip, old_netmask, old_gw, old_dns);
    char address[INET_ADDRSTRLEN];
    struct ifreq ifr;
    struct sockaddr_in sai, masksd;
    int sockfd;                     /* socket fd we use to manipulate stuff with */
    int selector;
    int is_ip_c = 0;
    unsigned char mask;

    char *p;
    /* Create a channel to the NET kernel. */
    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* get interface name */
    strncpy(ifr.ifr_name, interface_name, IFNAMSIZ);


    if (old_ip[0] != ip[0] || old_ip[1] != ip[1] || old_ip[2] != ip[2] || old_ip[3] != ip[3]) {
        is_ip_c = 1;
        snprintf(address, 16, "%d.%d.%d.%d", ip[0], ip[1], ip[2], ip[3]);
        printf("Address = %s\n", address);

        memset(&sai, 0, sizeof(struct sockaddr));
        sai.sin_family = AF_INET;
        sai.sin_port = 0;

        sai.sin_addr.s_addr = inet_addr(address);

        p = (char *) &sai;
        memcpy((((char *) &ifr + ifreq_offsetof(ifr_addr))),
               p, sizeof(struct sockaddr));

        if (ioctl(sockfd, SIOCSIFADDR, &ifr) < 0) {
            printf("\nioctl error ---  %d\n", errno);
            return ERROR_CODE;
        }
    }
///

    if (is_ip_c || old_gw[0] != gw[0] || old_gw[1] != gw[1] || old_gw[2] != gw[2] || old_gw[3] != gw[3]) {
        snprintf(address, 16, "%d.%d.%d.%d", old_gw[0], old_gw[1], old_gw[2], old_gw[3]);
        printf("\n\nDELLNULL ------%s\n\n", address);
        //delNullRoute(address);
        snprintf(address, 16, "%d.%d.%d.%d", gw[0], gw[1], gw[2], gw[3]);
        printf("Gateway = %s\n", address);

///
        struct rtentry route;
        struct sockaddr_in *addr;
        memset(&route, 0, sizeof(route));

////
        ////

        addr = (struct sockaddr_in *) &route.rt_gateway;
        addr->sin_family = AF_INET;
        snprintf(address, 16, "%d.%d.%d.%d", ip[0], ip[1], ip[2], ip[3]);
        addr->sin_addr.s_addr = inet_addr(address);
        addr = (struct sockaddr_in *) &route.rt_dst;
        addr->sin_family = AF_INET;
        snprintf(address, 16, "%d.%d.%d.%d", ip[0], ip[1], ip[2], 0);
        addr->sin_addr.s_addr = inet_addr(address);
        addr = (struct sockaddr_in *) &route.rt_genmask;
        addr->sin_family = AF_INET;
        snprintf(address, 16, "%d.%d.%d.%d", netmask[0], netmask[1], netmask[2], netmask[3]);
        addr->sin_addr.s_addr = inet_addr(address);
        // You need to add the interface name to the request
        route.rt_flags = RTF_UP | RTF_GATEWAY;
        route.rt_metric = 0;
        route.rt_dev = interface_name;
        // Now add the link-local route

        if ((ioctl(sockfd, SIOCADDRT, &route)) != 0) {
            perror("SIOCADDRT failed");
//            exit(1);
        }

        snprintf(address, 16, "%d.%d.%d.%d", gw[0], gw[1], gw[2], gw[3]);
        addr = (struct sockaddr_in *) &route.rt_gateway;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = inet_addr(address);
        addr = (struct sockaddr_in *) &route.rt_dst;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = INADDR_ANY;
        addr = (struct sockaddr_in *) &route.rt_genmask;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = INADDR_ANY;
        // You need to add the interface name to the request
        route.rt_flags = RTF_UP | RTF_GATEWAY;
        route.rt_metric = 0;
        route.rt_dev = interface_name;
        if ((ioctl(sockfd, SIOCADDRT, &route)) != 0) {
            perror("SIOCADDRT failed");
            return ERROR_CODE;
        }
    }


///////////////////////////////// Установка маски
    if (is_ip_c ||
        old_netmask[0] != netmask[0] ||
        old_netmask[1] != netmask[1] ||
        old_netmask[2] != netmask[2] ||
        old_netmask[3] != netmask[3]) {

        snprintf(address, 16, "%d.%d.%d.%d", netmask[0], netmask[1], netmask[2], netmask[3]);
        printf("Netmask = %s\n", address);
        memset(&masksd, 0, sizeof(struct sockaddr));
        masksd.sin_family = AF_INET;
        masksd.sin_port = 0;

        masksd.sin_addr.s_addr = inet_addr(address);

        p = (char *) &masksd;
        memcpy((((char *) &ifr + ifreq_offsetof(ifr_addr))),
               p, sizeof(struct sockaddr));

        if (ioctl(sockfd, SIOCSIFNETMASK, &ifr) < 0) { // Set subnet mask
            fprintf(stderr, "ioctl SIOCSIFNETMASK error");
            perror("");
            exit(EXIT_FAILURE);
        }
    }
    //ioctl(sockfd, SIOCGIFFLAGS, &ifr);

    //ifr.ifr_flags |= IFF_UP | IFF_RUNNING;
    // ifr.ifr_flags &= ~selector;  // unset something

    //ioctl(sockfd, SIOCSIFFLAGS, &ifr);

    if (old_gw[0] != gw[0] || old_gw[1] != gw[1] || old_gw[2] != gw[2] || old_gw[3] != gw[3]) {
        snprintf(address, 16, "%d.%d.%d.%d", old_gw[0], old_gw[1], old_gw[2], old_gw[3]);
        printf("\n\nDELLNULL ------%s\n\n", address);
        delNullRoute(address);
        snprintf(address, 16, "%d.%d.%d.%d", gw[0], gw[1], gw[2], gw[3]);
        printf("Gateway = %s\n", address);

///
        struct rtentry route;
        struct sockaddr_in *addr;
        memset(&route, 0, sizeof(route));

////
        ////
        addr = (struct sockaddr_in *) &route.rt_gateway;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = inet_addr(address);
        addr = (struct sockaddr_in *) &route.rt_dst;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = INADDR_ANY;
        addr = (struct sockaddr_in *) &route.rt_genmask;
        addr->sin_family = AF_INET;
        addr->sin_addr.s_addr = INADDR_ANY;
        // You need to add the interface name to the request
        route.rt_flags = RTF_UP | RTF_GATEWAY;
        route.rt_metric = 0;
        if ((ioctl(sockfd, SIOCADDRT, &route)) != 0) {
            perror("SIOCADDRT failed");
            return ERROR_CODE;
        }
    }

//    char command[100];
//    snprintf(command, sizeof(command), "ip route replace default via %s", address);
//
//    // Execute the command using system()
//    int result = system(command);
//
//    if (result == 0) {
//        printf("Default gateway changed successfully.\n");
//    } else {
//        printf("Failed to change the default gateway.\n");
//    }
///
    close(sockfd);
    ///
    if (old_dns[0] != dns[0] || old_dns[1] != dns[1] || old_dns[2] != dns[2] || old_dns[3] != dns[3]) {
        snprintf(address, 16, "%d.%d.%d.%d", dns[0], dns[1], dns[2], dns[3]);
        printf("DNS = %s\n", address);
        set_DNS(address);
    }
    return SUCCESS_CODE;
}

char check_dhcp_enabled() {
    FILE *file = fopen(INTERFACE_FILE, "r");
    if (file == NULL) {
        printf("Failed to open file: %s\n", INTERFACE_FILE);
        return -1;
    }

    char line[256];
    while (fgets(line, sizeof(line), file) != NULL) {
        if (strstr(line, "dhcp") != NULL) {
            fclose(file);
            return 1; // DHCP enabled
        }
    }

    if (fclose(file) != 0) {
        perror("Failed to close file");
        return -2;
    }
    return 0; // DHCP disabled
}

int set_DNS(const char *dns) {
    FILE *file = fopen(RESOLV_FILE, "w");
    if (file == NULL) {
        perror("Failed to open file");
        return -1;
    }

    const char *msg = "nameserver ";
    fwrite(msg, sizeof(char), strlen(msg), file);
    fwrite(dns, sizeof(char), strlen(dns), file);

    if (fclose(file) != 0) {
        perror("Failed to close file");
        return -2;
    }

    printf("File written and closed successfully.\n");
    return 0;
}

int delNullRoute(const char *address) {
    //int fd = socket(PF_INET, SOCK_DGRAM, IPPROTO_IP);
    //int fd = socket(AF_INET, SOCK_DGRAM, IPPROTO_IP);

    printf("Deleting route to %s\n", address);
    int fd = socket(AF_INET, SOCK_DGRAM, 0);

    struct rtentry route;
    memset(&route, 0, sizeof(route));

    struct sockaddr_in *addr = (struct sockaddr_in *) &route.rt_gateway;
    addr->sin_family = AF_INET;
    addr->sin_addr.s_addr = inet_addr(address);

    addr = (struct sockaddr_in *) &route.rt_dst;
    addr->sin_family = AF_INET;
    addr->sin_addr.s_addr = inet_addr("0.0.0.0");  // Replace with the correct destination IP address

    addr = (struct sockaddr_in *) &route.rt_genmask;
    addr->sin_family = AF_INET;
    addr->sin_addr.s_addr = inet_addr("0.0.0.0");

    route.rt_flags = RTF_UP | RTF_GATEWAY;
    //route.rt_metric = 0;

    int result = ioctl(fd, SIOCDELRT, &route);
    if (result < 0) {
        perror("ioctl");
        close(fd);
        return 0;
    }

    close(fd);
    return 1;
}

int execute_command(const char *command, char result[16]) {
    char buffer[128];
    FILE *pipe = popen(command, "r");

    if (pipe == NULL) {
        printf("Failed to execute command\n");
        return 0;
    }

    // Read command output line by line
    if (fgets(buffer, sizeof(buffer), pipe) != NULL) {
        // Remove newline character
        size_t len = strlen(buffer);
        if (len > 0 && buffer[len - 1] == '\n')
            buffer[len - 1] = '\0';

        // Allocate memory for the result string
        size_t result_len = strlen(buffer);

        // Concatenate the current line to the result string
        for (int i = 0; i < INET_ADDRSTRLEN; ++i) {
            result[i] = buffer[i];
        }
    }

    pclose(pipe);
    return 1;
}

int parse_ip_address(const char *ip_string, unsigned char numbers[4]) {
    char *token = strtok(ip_string, ".");
    int i = 0;
    while (token != NULL && i < 4) {
        numbers[i] = atoi(token);
        token = strtok(NULL, ".");
        i++;
    }
    if (i != 4) {
        printf("Invalid IP address format.\n");
        return -1;
    }
    return 0;
}
